﻿
declare @RepId int;
select @RepId = max(id) + 1 from dbo.Reports;
if (@RepId is null) set @RepId = 1;
insert into dbo.[Reports] ([id], [ReportName], [GroupId], [ReportDesc], [ReturnsNoData],
[ReportVer], [LastModified]) values (@RepId, 
N'Прибыль по типам роботов', null,
N'Отчёт показывает прибыли/убытки с группировкой по типам роботов', 
0, 1, '2016-10-27T15:41:12');

declare @NextSqlPartId int;
select @NextSqlPartId = MAX(id) from [dbo].[ReportSqlParts];
if (@NextSqlPartId is null) set @NextSqlPartId = 0;

set @NextSqlPartId = @NextSqlPartId + 1;
insert into dbo.[ReportSqlParts]([id], [ReportId], [SerialNumber],
[PartTypeId], [SqlText], [TopRows]) values (@NextSqlPartId, @RepId, 
1,1,N'SELECT ords.Robot, bots.RobotName, SUM(ords.Profit) as ProfitSum, AVG(ords.Profit) as ProfitAvg',
null);

set @NextSqlPartId = @NextSqlPartId + 1;
insert into dbo.[ReportSqlParts]([id], [ReportId], [SerialNumber],
[PartTypeId], [SqlText], [TopRows]) values (@NextSqlPartId, @RepId, 
2,2,N'FROM dbo.OrderState as ords LEFT OUTER JOIN 
dbo.Robots as bots ON ords.Robot = bots.id ',
null);

set @NextSqlPartId = @NextSqlPartId + 1;
insert into dbo.[ReportSqlParts]([id], [ReportId], [SerialNumber],
[PartTypeId], [SqlText], [TopRows]) values (@NextSqlPartId, @RepId, 
3,3,N'WHERE ords.MsgType in (2, 3, 4, 8)',
null);

set @NextSqlPartId = @NextSqlPartId + 1;
insert into dbo.[ReportSqlParts]([id], [ReportId], [SerialNumber],
[PartTypeId], [SqlText], [TopRows]) values (@NextSqlPartId, @RepId, 
4,4,N'GROUP BY ords.Robot, bots.RobotName',
null);

set @NextSqlPartId = @NextSqlPartId + 1;
insert into dbo.[ReportSqlParts]([id], [ReportId], [SerialNumber],
[PartTypeId], [SqlText], [TopRows]) values (@NextSqlPartId, @RepId, 
5,6,N'ORDER BY ords.Robot, bots.RobotName',
null);

declare @ParPos int; set @ParPos = 0;
declare @NextParId int;
select @NextParId = MAX(id) from [dbo].[ReportParams];
if (@NextParId is null) set @NextParId = 0;

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'Время с',
N'ords.MsgTime', @ParPos,4, 0, 3,
N'01.10.2016 00:00:00',
N'Фильтр позволяет учесть сделки, начиная с указанного времени',
0,
null,
null,null,
N'01.10.2016 00:00:00',
N'@TimeFrom',
null,0,0,0,
null,
0);

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'Время по',
N'ords.MsgTime', @ParPos,6, 0, 3,
N'31.10.2016 23:59:59',
N'Фильтр позволяет учесть сделки по указанное время',
0,
null,
null,null,
N'31.10.2016 23:59:59',
N'@TimeTo',
null,0,0,0,
null,
0);

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'Magic начиная с',
N'ords.Magic', @ParPos,4, 0, 1,
N'1',
null,
0,
null,
null,null,
N'1',
N'@MagicFrom',
null,0,0,0,
null,
0);

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'по Magic',
N'ords.Magic', @ParPos,6, 0, 1,
N'10000',
null,
0,
null,
null,null,
N'10000',
N'@MagicTo',
null,0,0,0,
null,
0);

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'Валюта',
N'ords.Symbol', @ParPos,1, 0, 0,
N'EURUSD',
N'Фильтр позволяет анализировать прибыль только у роботов, работающих с указанной валютной парой',
0,
N'SELECT CurrencySymbol FROM dbo.CurrencySymbols ORDER BY CurrencySymbol ASC;',
0,0,
N'EURUSD',
N'@Symbol',
null,0,0,0,
null,
0);

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'Тип робота',
N'ords.Robot', @ParPos,1, 0, 1,
N'378',
N'Фильтр позволяетанализировать прибыль только по роботам выбранного типа',
0,
N'SELECT id, RobotName FROM dbo.Robots ORDER BY RobotName;',
1,0,
N'Mine',
N'@Robot',
null,0,0,0,
null,
0);

declare @NextFieldId int;
select @NextFieldId = MAX(id) from [dbo].[ReportFields];
if (@NextFieldId is null) set @NextFieldId = 0;

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
1, N'ords.Robot',
null,
N'№ типа робота',
1,null
,N'Числовой идентификатор типа робота',
null,200,1,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
2, N'bots.RobotName',
null,
N'Тип робота',
1,null
,N'Название типа робота',
null,240,1,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
3, N'SUM(ords.Profit)',
N'ProfitSum',
N'Сумма прибыли',
1,null
,N'Сумма прибыли',
null,240,1,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
4, N'AVG(ords.Profit)',
N'ProfitAvg',
N'Средняя прибыль',
1,null
,N'Средняя прибыль',
null,200,1,null);
