﻿
declare @RepId int;
select @RepId = max(id) + 1 from dbo.Reports;
if (@RepId is null) set @RepId = 1;
insert into dbo.[Reports] ([id], [ReportName], [GroupId], [ReportDesc], [ReturnsNoData],
[ReportVer], [LastModified]) values (@RepId, 
N'Информация по ордерам', null,
N'Отчёт позволяет просматривать торговые операции, выполненные роботами', 
0, 1, '2016-10-26T17:36:19');

declare @NextSqlPartId int;
select @NextSqlPartId = MAX(id) from [dbo].[ReportSqlParts];
if (@NextSqlPartId is null) set @NextSqlPartId = 0;

set @NextSqlPartId = @NextSqlPartId + 1;
insert into dbo.[ReportSqlParts]([id], [ReportId], [SerialNumber],
[PartTypeId], [SqlText], [TopRows]) values (@NextSqlPartId, @RepId, 
1,1,N'SELECT  ords.MsgTime',
1000);

set @NextSqlPartId = @NextSqlPartId + 1;
insert into dbo.[ReportSqlParts]([id], [ReportId], [SerialNumber],
[PartTypeId], [SqlText], [TopRows]) values (@NextSqlPartId, @RepId, 
2,2,N'FROM dbo.OrderState as ords LEFT OUTER JOIN 
dbo.OrderMsgTypes as mtypes ON 
ords.MsgType = mtypes.id LEFT OUTER JOIN 
dbo.Robots as bots ON 
ords.Robot = bots.id ',
null);

set @NextSqlPartId = @NextSqlPartId + 1;
insert into dbo.[ReportSqlParts]([id], [ReportId], [SerialNumber],
[PartTypeId], [SqlText], [TopRows]) values (@NextSqlPartId, @RepId, 
3,3,null,
null);

set @NextSqlPartId = @NextSqlPartId + 1;
insert into dbo.[ReportSqlParts]([id], [ReportId], [SerialNumber],
[PartTypeId], [SqlText], [TopRows]) values (@NextSqlPartId, @RepId, 
4,6,N'ORDER BY ords.MsgTime DESC, ords.id DESC',
null);

declare @ParPos int; set @ParPos = 0;
declare @NextParId int;
select @NextParId = MAX(id) from [dbo].[ReportParams];
if (@NextParId is null) set @NextParId = 0;

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'Magic Number',
N'ords.Magic', @ParPos,1, 0, 1,
N'3001',
N'Magic Number робота, работавшего с ордером',
0,
null,
null,null,
N'3001',
N'@Magic',
null,0,0,0,
null,
0);

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'Время с',
N'ords.MsgTime', @ParPos,4, 0, 3,
N'01.10.2016 00:00:00',
N'Если включить фильтр - в отчёт попадут только те действия с ордерами, которые были выполнены начиная с указанного времени',
0,
null,
null,null,
N'01.10.2016 00:00:00',
N'@TimeFrom',
null,0,0,0,
null,
0);

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'Время по',
N'ords.MsgTime', @ParPos,6, 0, 3,
N'31.10.2016 23:59:59',
N'Если включить фильтр - в отчёт попадут только действия с ордерами, выполненные по указанное время',
0,
null,
null,null,
N'31.10.2016 23:59:59',
N'@TimeTo',
null,0,0,0,
null,
0);

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'Валюта',
N'ords.Symbol', @ParPos,1, 0, 0,
N'EURUSD',
N'Ограничивает отчёт только операциями по указанной валютной паре',
0,
N'SELECT CurrencySymbol FROM dbo.CurrencySymbols ORDER BY CurrencySymbol ASC;',
0,0,
N'EURUSD',
N'@Symbol',
null,0,0,0,
null,
0);

set @NextParId = @NextParId + 1;
set @ParPos = @ParPos + 1;
insert into dbo.[ReportParams]([id], [ReportId], [ParName],
[ParField], [ParPos], [FilterType], [Enabled], [ParType], [DefValue],
[ParDesc], [OrFlag], [SecondarySql], [DisplayIndex],
[ValueIndex], [DefDisplay], [ParNameSql], [PartSerialNumber],
[NoAndWhere], [HideFromUser], [AlwaysOn], [TextForSet], [CommandParam])
values (@NextParId, @RepId, 
N'Тип робота',
N'ords.Robot', @ParPos,1, 0, 1,
N'378',
N'Фильтр позволяет показать действия, выполненные только указанным типом робота',
0,
N'SELECT id, RobotName FROM dbo.Robots ORDER BY RobotName;',
1,0,
N'Mine',
N'@Robot',
null,0,0,0,
null,
0);

declare @NextFieldId int;
select @NextFieldId = MAX(id) from [dbo].[ReportFields];
if (@NextFieldId is null) set @NextFieldId = 0;

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
1, N'ords.MsgTime',
null,
N'Время',
1,null
,N'Время записи сообщения о действии с ордером',
null,140,1,N'G');

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
2, N'mtypes.TypeName',
null,
N'Действие',
1,null
,N'Тип действия с ордером - открытие, СЛ, ТП, активация отложенного ордера и т.д.',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
3, N'ords.Magic',
null,
N'Magic',
1,null
,N'Magic Number робота, работающего с ордером',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
4, N'ords.Ticket',
null,
N'Ticket',
1,null
,N'Тикет ордера',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
5, N'ords.Symbol',
null,
N'Валюта',
1,null
,N'Тикер валютной пары, по которой был открыт ордер',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
6, N'(CASE ords.OrderType WHEN 0 THEN ''BUY'' WHEN 1 THEN ''SELL'' WHEN 2 THEN ''BUY LIMIT'' WHEN 3 THEN ''SELL LIMIT'' WHEN 4 THEN ''BUY STOP'' WHEN 5 THEN ''SELL STOP'' ELSE ''UNKNOWN'' END)',
N'TextOrdType',
N'Тип орд.',
1,null
,N'Тип ордера - BUY, SELL, BUY LIMIT и т.д.',
null,90,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
7, N'ords.OpenTime',
null,
N'Открыт',
1,null
,N'Дата и время открытия ордера',
null,140,0,N'G');

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
8, N'ords.Volume',
null,
N'Лоты',
1,null
,N'Количество лотов ордера',
null,80,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
9, N'ords.OpenPrice',
null,
N'Цена откр.',
1,null
,N'Цена открытия ордера',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
10, N'ords.SL',
null,
N'SL',
1,null
,N'Stop Loss, установленный для ордера',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
11, N'ords.TP',
null,
N'TP',
1,null
,N'Take Profit, установленный для ордера',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
12, N'ords.CloseTime',
null,
N'Закрыт',
1,null
,N'Время закрытия ордера',
null,140,0,N'G');

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
13, N'ords.ClosePrice',
null,
N'Цена закр.',
1,null
,N'Цена, по которой был закрыт ордер',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
14, N'ords.Profit',
null,
N'Прибыль',
1,null
,N'Прибыль или убыток, полученные по ордеру',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
15, N'ords.Comment',
null,
N'Комментарий',
1,null
,N'Комментарий, указанный для ордера',
null,140,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
16, N'bots.RobotName',
null,
N'Робот',
0,null
,N'Название типа робота',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
17, N'CAST(ords.IsVirtual AS bit)',
N'VirtualBit',
N'Вирт.',
1,null
,N'Флаг виртуального ордера',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
18, N'ords.MStep',
null,
N'Шаг',
0,null
,N'Значение шага мартингейла для ордера',
null,80,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
19, N'ords.Balance',
null,
N'Баланс',
0,null
,N'Сумма на счёте на момент после выполнения действия с ордером',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
20, N'ords.FreeMargin',
null,
N'Маржа',
0,null
,N'Свободная маржа счёта на момент выполнения действия с ордером',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
21, N'ords.Account',
null,
N'Счёт',
0,null
,N'Номер счёта, на котором работает робот',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
22, N'ords.UserInt',
null,
N'Польз.',
0,null
,N'Пользовательское значение, которое может быть по-разному использовано разными типами роботов',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
23, N'CAST(ords.IsDemo AS bit)',
N'DemoBit',
N'Демо',
0,null
,N'Флаг работы робота на демо-счёте',
null,80,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
24, N'ords.Expiration',
null,
N'Истечение',
0,null
,N'Время истечения для отложенного ордера',
null,100,0,N'G');

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
25, N'ords.Build',
null,
N'Версия',
0,null
,N'Номер версии робота, выполнившего действие с ордером',
null,80,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
26, N'ords.Swap',
null,
N'swap',
0,null
,N'Сумма swap для ордера',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
27, N'ords.Comission',
null,
N'Комиссия',
0,null
,N'Сумма комиссии для ордера',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
28, N'ords.Robot',
null,
N'№ типа',
0,null
,N'Идентификатор типа робота',
null,100,0,null);

set @NextFieldId = @NextFieldId + 1;
insert into dbo.[ReportFields]([id], [ReportId], [FieldPos],
[FieldName], [FieldAlias], [Caption], [ShowField],
[StatFunc], [FieldDesc], [PartSerialNumber], [FieldWidth],
[DontAddField], [FieldFormat]) values (@NextFieldId, @RepId, 
29, N'ords.id',
null,
N'№ записи',
0,null
,N'Идентификатор записи о действии с ордером в таблице БД',
null,100,0,null);
